Summary: The BSD 4.4 version of make.
Name: pmake
Version: 2.1.34
Release: 6
Copyright: BSD
Group: Development/Tools
Source0: ftp://ftp.icsi.berkeley.edu/pub/ai/stolcke/software/pmake-%{version}.tar.Z
Source1: pmake-sys-alpha.mk
Source2: pmake-sys-i386.mk
Source3: pmake-sys-sparc.mk
Patch0: pmake-2.1.33-glibc.patch
ExcludeArch: ia64
BuildRoot: %{_tmppath}/%{name}-root

%description
Make is a GNU tool which allows users to build and install programs
without any significant knowledge of the build process.  Details about
how the program should be built are included in the program's
Makefile.  Pmake is a particular version (BSD 4.4) of make.  Pmake
supports some additional syntax which is not in the standard make
program.  Some Berkeley programs have Makefiles written for pmake.

Pmake should be installed on your system so that you will be able to
build programs which require using pmake instead of make.

%package customs
Summary: A remote execution facility for pmake.
Group: Development/Tools

%description customs
Customs is a remote execution facility for PMake (the BSD 4.4 version
of make). Customs is designed to run on a network of machines with a
consistent, shared filesystem. Customs requires Sun RPC in order to
use XDR (eXternal Data Representation) routines for logging functions.

A single server is designated as the master agent and is additionally
responsible for noting when a machine goes down, from which machines
any given machine will accept jobs and parcelling out available
machines to requesting clients. The job of master is not given to any
one machine but is instead decided among the active agents whenever
the previous master dies.

Clients are provided to alter the availability criteria for the local
machine (importquota); find the status of all registered hosts on the
net (reginfo); abort, restart or ping any customs agent on the network
(cctrl); export a command from the shell (export); and accept log
information from all hosts on the net (logd).

Install pmake-customs if you need a remote execution facility for pmake.

%prep
%setup -q -n pmake
%patch0 -p1

for I in alpha i386 sparc; do
	cp -f $RPM_SOURCE_DIR/pmake-sys-$I.mk ./lib/mk/sys-$I.mk
done
for I in i486 i586 i786; do
	ln -s sys-i386.mk lib/mk/sys-$I.mk
done
for I in sparc64 sparcv9; do
	ln -s sys-sparc.mk lib/mk/sys-$I.mk
done

for I in makefile config.mk common.mk doc/Makefile
do
  perl -pi -e '
    s,= /usr/local/bin,= %{_bindir},;
    s,= /usr/local/lib/pmake,= %{_datadir}/mk,;
    s,= /usr/bin,= %{_bindir},;
    s,= /usr/sbin,= %{_sbindir},;
    s,= /usr/lib/pmake,= %{_datadir}/mk,;
    s,= /usr/lib,= %{_libdir},;
    s,= /usr/include,= %{_includedir},;
    s,/usr/man,%{_mandir},;
    s,/usr/lib/tmac,= %{_datadir}/tmac,
    ' $I
done

%build
#
# Bootstrap build of local pmake with makefile's
mkdir bin
make	CC="gcc $RPM_OPT_FLAGS" SYSFLAGS="-DSYSV -DSVR4" \
	BINDIR=`pwd`/bin LIBDIR=`pwd`/lib/pmake
make	CC="gcc $RPM_OPT_FLAGS" SYSFLAGS="-DSYSV -DSVR4" \
	BINDIR=`pwd`/bin LIBDIR=`pwd`/lib/pmake install

#
# Then build pmake using pmake & Makefile's
`pwd`/bin/pmake CC="gcc $RPM_OPT_FLAGS" SYSFLAGS="-DSYSV -DSVR4" \
    ETCDIR=%{_sbindir} \
    MANDIR=%{_mandir} \
    LIBDIR=%{_datadir}/pmake \
    USRLIBDIR=%{_libdir} \
    INCLUDEDIR=%{_includedir}/customs \
	all

%install
rm -rf ${RPM_BUILD_ROOT}
mkdir -p ${RPM_BUILD_ROOT}%{_bindir}
mkdir -p ${RPM_BUILD_ROOT}%{_sbindir}
mkdir -p ${RPM_BUILD_ROOT}%{_includedir}
mkdir -p ${RPM_BUILD_ROOT}%{_libdir}
mkdir -p ${RPM_BUILD_ROOT}%{_mandir}

`pwd`/bin/pmake CC="gcc $RPM_OPT_FLAGS" SYSFLAGS="-DSYSV -DSVR4" \
    DESTDIR=${RPM_BUILD_ROOT} \
    ETCDIR=${RPM_BUILD_ROOT}%{_sbindir} \
    MANDIR=${RPM_BUILD_ROOT}%{_mandir} \
    LIBDIR=${RPM_BUILD_ROOT}%{_datadir}/pmake \
    USRLIBDIR=${RPM_BUILD_ROOT}%{_libdir} \
    INCLUDEDIR=${RPM_BUILD_ROOT}%{_includedir}/customs \
	install

# XXX rename export.1 to customs_export.1 to avoid conflict with bash export.1.
mv -f ${RPM_BUILD_ROOT}%{_mandir}/man1/{export,customs_export}.1
mv -f customs/README customs/README.customs

%clean
rm -rf ${RPM_BUILD_ROOT}

%files
%defattr(-,root,root)
%doc CHANGES INSTALL README customs/README.customs etc tests
%doc doc/tutorial.* doc/prefix.*
%attr(755,root,root)	%{_bindir}/pmake
%{_bindir}/vmake
%{_mandir}/man1/pmake.*
%{_datadir}/mk

%files customs
%defattr(-,root,root)
%{_bindir}/reginfo
%attr(755,root,root)	%{_bindir}/export
%{_bindir}/rexport
%{_sbindir}/importquota
%{_sbindir}/cctrl
%{_sbindir}/logd
%{_sbindir}/customs

%{_mandir}/man1/reginfo.*
%{_mandir}/man1/customs_export.*
%{_mandir}/man1/rexport.*
%{_mandir}/man8/customs.*
%{_mandir}/man8/cctrl.*
%{_mandir}/man8/importquota.*
%{_mandir}/man8/logd.*

%{_libdir}/libcustoms*
%{_includedir}/customs

%changelog
* Wed Jul 12 2000 Prospector <bugzilla@redhat.com>
- automatic rebuild

* Fri Jun 16 2000 Jeff Johnson <jbj@redhat.com>
- rename export.1 to customs_export.1 to avoid conflict with bash export.1.

* Wed Jun 14 2000 Jeff Johnson <jbj@redhat.com>
- FHS packaging.
- avoid ia64 for now.

* Thu Feb 03 2000 Elliot Lee <sopwith@redhat.com>
- Try to fix bug number 8675

* Mon Jan 31 2000 Cristian Gafton <gafton@redhat.com>
- rebuild to fix depenencies

* Thu Jan 13 2000 Jeff Johnson <jbj@redhat.com>
- update to 2.1.34.

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com> 
- auto rebuild in the new build environment (release 5)

* Fri Mar 19 1999 Jeff Johnson <jbj@redhat.com>
- turn off setuid root "just in case". See etc/SECURITY in /usr/doc.

* Mon Aug 17 1998 Jeff Johnson <jbj@redhat.com>
- build root

* Fri May 01 1998 Prospector System <bugs@redhat.com>
- translations modified for de, fr, tr

* Tue Dec 16 1997 Otto Hammersmith <otto@redhat.com>
- fixed bug related to rules to build .a files.

* Thu Oct 23 1997 Cristian Gafton <gafton@redhat.com>
- updated spec file

* Mon Jul 21 1997 Erik Troan <ewt@redhat.com>
- built against glibc
